package com.xunao.effectdemo.activity;

import android.app.Activity;
import android.content.ClipData;
import android.os.Bundle;
import android.util.Log;
import android.view.DragEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import androidx.annotation.Nullable;

import com.xunao.effectdemo.R;

/**
 * author : 程中强
 * e-mail : 740479946@qq.com
 * date : 2022/8/3116:18
 * desc :
 * version: 1.0
 */
public class SequentialDragActivity extends Activity {

	private static String TAG = "SequentialDragActivity";
	private RelativeLayout rl1,rl2,rl3,rl4,rl5;
	private RelativeLayout view1,view2,view3,view4,view5;
	@Override
	protected void onCreate(@Nullable Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_sequential_drag);
		rl1 = findViewById(R.id.rl_1);
		rl2 = findViewById(R.id.rl_2);
		rl3 = findViewById(R.id.rl_3);
		rl4 = findViewById(R.id.rl_4);
		rl5 = findViewById(R.id.rl_5);

		view1 = findViewById(R.id.view1);
		view2 = findViewById(R.id.view2);
		view3 = findViewById(R.id.view3);
		view4 = findViewById(R.id.view4);
		view5 = findViewById(R.id.view5);
		setDrag(rl1,view1);
		setDrag(rl2,view2);
		setDrag(rl3,view3);
		setDrag(rl4,view4);
		setDrag(rl5,view5);
	}

	private void setDrag(View view1,View view2){
		view2.setOnTouchListener(new View.OnTouchListener() {
			@Override
			public boolean onTouch(View view, MotionEvent motionEvent) {

				//定义一个裁剪数据对象.随便定义一个就行,本demo用不到这个clipData.
				ClipData clipData = new ClipData(ClipData.newPlainText("view1", "aaa"));

				//定义一个拖拽阴影
				View.DragShadowBuilder myShadow = new View.DragShadowBuilder(view);

				//开始拖拽. 第三个参数在拖拽过程用来传递数据,这里我传view即被拖动的view自己,
				//后面可在DragEvent中获得这个参数view
				view.startDrag(clipData, myShadow, view, 0);

				return false;
			}
		});
		view1.setOnDragListener(onDragListener1);
	}

	View.OnDragListener onDragListener1 = new View.OnDragListener() {
		@Override
		public boolean onDrag(View view, DragEvent dragEvent) {
			Log.i(TAG, "container.onDrag called======");
			switch (dragEvent.getAction()) {
				case DragEvent.ACTION_DRAG_STARTED://开始.当有view被拖的时候收到此事件
//                        Log.i(TAG, "开始");
					((View) dragEvent.getLocalState()).setVisibility(View.INVISIBLE);
					break;
				case DragEvent.ACTION_DRAG_ENTERED://进入.当被拖view手指按压的位置进入本view的瞬间收到此事件
//                        Log.i(TAG, "进入");
					break;
				case DragEvent.ACTION_DRAG_LOCATION://位于.当被拖view手指按压的位置在本view上方的时候收到此事件
//                        Log.i(TAG, "位于");

					//此时dragEvent里包含要被拖view
					View draggingView = (View) dragEvent.getLocalState();
					//当前容器
					ViewGroup thisContainer = ((ViewGroup) view);
					//被拖拽view覆盖的view
					View coveredView = thisContainer.getChildAt(0);
					//当拖拽的view跟被覆盖的view不同时
					if (draggingView != coveredView) {
						ViewGroup draggingViewContainer = (ViewGroup) draggingView.getParent();
						//两个容器交换子view
						thisContainer.removeView(coveredView);
						draggingViewContainer.removeView(draggingView);
						thisContainer.addView(draggingView);
						draggingViewContainer.addView(coveredView);
					}
					break;
				case DragEvent.ACTION_DROP://丢入.当被拖view在本view上方手指释放开,收到此事件
//                        Log.i(TAG, "丢入");
					Log.i(TAG, "丢入view_container2");
					break;
				case DragEvent.ACTION_DRAG_EXITED://出去.当被拖view手指按压位置从本view拖出去收到此事件
//                        Log.i(TAG, "出去");
					break;
				case DragEvent.ACTION_DRAG_ENDED://结束.手指释放拖拽结束收到此事件.
//                        Log.i(TAG, "结束");
					((View) dragEvent.getLocalState()).setVisibility(View.VISIBLE);
					break;
				default:
					break;
			}
			//一定要为true
			return true;
		}
	};
}
